/*
 * Copyright 2009 Nicolas LE GRIEL.
 * 
 * Les sources qui constituent ce projet nlegriel-dvp-defi5 de mme que 
 * la documentation associe sont la proprit de leur auteur.
 * 
 * Je donne mon accord au site developpez.com pour l'utilisation de 
 * tout ou partie des sources et de la documentation de ce projet dans 
 * les pages developpez.com
 */
package com.developpez.nlegriel.defi5;


/**
 * Simple couple permettant d'associer un cube  une pice du puzzle.
 * <p>
 * Ce type de couple n'a d'utilit que pour un affichage 3D d'un 
 * placement des pices du puzzle par rapport  une figure.
 *
 * @author Nicolas LE GRIEL
 */
public class CubeCover {
	public Cube cube;
	public PuzzlePart part;

	public CubeCover(Cube cube, PuzzlePart part) {
		this.cube = cube;
		this.part = part;
	}
	
	@Override
	public boolean equals(Object o) {
		if (o instanceof CubeCover)
			return cube.equals(((CubeCover) o).cube) && part == ((CubeCover) o).part;
		return false;
	}
	
	@Override
	public int hashCode() {
		return 1000 * cube.hashCode() + part.toString().charAt(0);
	}
}
