/*
 * Copyright 2009 Nicolas LE GRIEL.
 * 
 * Les sources qui constituent ce projet nlegriel-dvp-defi5 de mme que 
 * la documentation associe sont la proprit de leur auteur.
 * 
 * Je donne mon accord au site developpez.com pour l'utilisation de 
 * tout ou partie des sources et de la documentation de ce projet dans 
 * les pages developpez.com
 */
package com.developpez.nlegriel.defi5;

import static junit.framework.Assert.assertEquals;
import static junit.framework.Assert.assertTrue;

import org.junit.Test;

import com.developpez.nlegriel.defi5.Cube;

public class CubeTest {
	@Test
	public void compareTo() {
		Cube c1 = new Cube();
		c1.x = 1;
		c1.y = 2;
		c1.z = 3;
		Cube c2 = new Cube();
		c2.x = 1;
		c2.y = 2;
		c2.z = 3;
		assertEquals(0, c1.compareTo(c2));
		
		c2.x = 0;
		assertTrue(c1.compareTo(c2) > 0);
		
		c2.x = 1;
		c2.y = 1;
		assertTrue(c1.compareTo(c2) > 0);
		
		c2.y = 2;
		c2.z = 2;
		assertTrue(c1.compareTo(c2) > 0);
		
		c2.z = 3;
		c1.x = 0;
		assertTrue(c1.compareTo(c2) < 0);
		
		c1.x = c1.y = c1.z = c2.x = c2.y = c2.z = 1;
		assertEquals(0, c1.compareTo(c2));
	}
	
	@Test
	public void translate() {
		Cube c1 = new Cube(1, 2, 3);
		Cube c2 = new Cube();
		Cube c = c1.translate(c2);
		assertEquals(c, c1);
		
		c2 = new Cube(-1, -2, -3);
		c = c1.translate(c2);
		assertEquals(c, new Cube());
		
		c2 = new Cube(1, 1, 1);
		c = c1.translate(c2);
		assertEquals(c, new Cube(2, 3, 4));
	}
}
