/*
 * Copyright 2009 Nicolas LE GRIEL.
 * 
 * Les sources qui constituent ce projet nlegriel-dvp-defi5 de mme que 
 * la documentation associe sont la proprit de leur auteur.
 * 
 * Je donne mon accord au site developpez.com pour l'utilisation de 
 * tout ou partie des sources et de la documentation de ce projet dans 
 * les pages developpez.com
 */
package com.developpez.nlegriel.defi5;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;

import java.util.HashSet;
import java.util.Set;

import org.junit.Test;

import com.developpez.nlegriel.defi5.Cube;
import com.developpez.nlegriel.defi5.IntegerMatrix3x3;

public class IntegerMatrix3x3Test {
	@Test
	public void operate() {
		assertEquals(new Cube(), IntegerMatrix3x3.X.operate(new Cube()));
		
		assertEquals(new Cube(1, 0, 0), IntegerMatrix3x3.X.operate(new Cube(1, 0, 0)));
		assertEquals(new Cube(0, 0, 1), IntegerMatrix3x3.X.operate(new Cube(0, 1, 0)));
		assertEquals(new Cube(1, 0, 0), IntegerMatrix3x3.Y.operate(new Cube(0, 0, 1)));
		assertEquals(new Cube(0, 1, 0), IntegerMatrix3x3.Z.operate(new Cube(1, 0, 0)));
		
		assertEquals(new Cube(0, -1, 0), IntegerMatrix3x3.X.multiply(IntegerMatrix3x3.X).operate(new Cube(0, 1, 0)));

		assertEquals(new Cube(1, 0, 0), IntegerMatrix3x3.Y.multiply(IntegerMatrix3x3.X).operate(new Cube(0, 1, 0)));
	}
	
	@Test
	public void multiply() {
		assertEquals(IntegerMatrix3x3.X, IntegerMatrix3x3.X.multiply(IntegerMatrix3x3.ID));
		assertEquals(IntegerMatrix3x3.X, IntegerMatrix3x3.ID.multiply(IntegerMatrix3x3.X));
		
		assertEquals(new IntegerMatrix3x3(), new IntegerMatrix3x3().multiply(IntegerMatrix3x3.X));
		
		assertEquals(IntegerMatrix3x3.ID, IntegerMatrix3x3.X.multiply(IntegerMatrix3x3.X.multiply(IntegerMatrix3x3.X.multiply(IntegerMatrix3x3.X))));
	}
	
	@Test
	public void equals() {
		assertEquals(IntegerMatrix3x3.ID, IntegerMatrix3x3.ID);
		assertFalse(IntegerMatrix3x3.X.equals(IntegerMatrix3x3.Y));
	}
	
	/**
	 * Le but de ce test est simplement de prouver que les transformations de
	 * la collection {@link IntegerMatrix3x3#ALL_ROTATIONS} sont toutes 
	 * distinctes deux  deux.
	 */
	@Test
	public void ALL_ROTATIONS() {
		Set<IntegerMatrix3x3> set = new HashSet<IntegerMatrix3x3>(IntegerMatrix3x3.ALL_ROTATIONS);
		assertEquals("Il existe au moins deux rotations identiques", IntegerMatrix3x3.ALL_ROTATIONS.size(), set.size());
	}
}
