/*
 * Copyright 2009 Nicolas LE GRIEL.
 * 
 * Les sources qui constituent ce projet nlegriel-dvp-defi5 de mme que 
 * la documentation associe sont la proprit de leur auteur.
 * 
 * Je donne mon accord au site developpez.com pour l'utilisation de 
 * tout ou partie des sources et de la documentation de ce projet dans 
 * les pages developpez.com
 */
package com.developpez.nlegriel.defi5;

import static org.junit.Assert.assertTrue;

import org.junit.Test;

import com.developpez.nlegriel.defi5.Cube;
import com.developpez.nlegriel.defi5.PuzzlePart;
import com.developpez.nlegriel.defi5.PuzzlePartPositionsProvider;

public class PuzzlePartPositionsProviderTest {
	@Test
	public void getTranslationsOfPart() {
		// Faire le test pice par pice pour tre sr qu'il n'y a pas de problmes.
		// On commence par les pices dont l'enveloppe cubique est de ct 2 :
		Cube[][] partTranslations = new Cube[][] {
			PuzzlePart.A.getPositions()[0],
			PuzzlePart.B.getPositions()[0],
			PuzzlePart.P.getPositions()[0],
			PuzzlePart.V.getPositions()[0]
		};
		for (int p=0; p<partTranslations.length; p++) {
			Cube[][] allTranslations = PuzzlePartPositionsProvider.getTranslationsOfPart(partTranslations[p]);
			for (int i=0; i<allTranslations.length; i++)
				for (int j=0; j<allTranslations[i].length; j++)
					for (int k=0; k<allTranslations[i].length; k++)
						assertTrue(PuzzlePartTest.maxDistance(allTranslations[i][j], allTranslations[i][k]) < 2);
		}
		
		// On s'occupe maintenant des pices dont l'enveloppe cubique est de ct 3 :
		partTranslations = new Cube[][] {
			PuzzlePart.T.getPositions()[0],
			PuzzlePart.L.getPositions()[0],
			PuzzlePart.Z.getPositions()[0]
		};
		for (int p=0; p<partTranslations.length; p++) {
			Cube[][] allTranslations = PuzzlePartPositionsProvider.getTranslationsOfPart(partTranslations[p]);
			for (int i=0; i<allTranslations.length; i++)
				for (int j=0; j<allTranslations[i].length; j++)
					for (int k=0; k<allTranslations[i].length; k++)
						assertTrue(PuzzlePartTest.maxDistance(allTranslations[i][j], allTranslations[i][k]) < 3);
		}
	}
}
