/*
 * Copyright 2009 Nicolas LE GRIEL.
 * 
 * Les sources qui constituent ce projet nlegriel-dvp-defi5 de mme que 
 * la documentation associe sont la proprit de leur auteur.
 * 
 * Je donne mon accord au site developpez.com pour l'utilisation de 
 * tout ou partie des sources et de la documentation de ce projet dans 
 * les pages developpez.com
 */
package com.developpez.nlegriel.defi5;

import static junit.framework.Assert.assertEquals;
import static junit.framework.Assert.assertNotNull;
import static junit.framework.Assert.assertTrue;

import org.junit.Test;

import com.developpez.nlegriel.defi5.Cube;
import com.developpez.nlegriel.defi5.PuzzlePart;

public class PuzzlePartTest {
	/**
	 * Calcule le plus gros cart de coordonnes entre deux cubes.
	 */
	public static int maxDistance(Cube c1, Cube c2) {
		int max = 0;
		max = Math.abs(c1.x - c2.x);
		int i = Math.abs(c1.y - c2.y);
		if (i > max)
			max = i;
		i = Math.abs(c1.z - c2.z);
		if (i > max)
			max = i;
		return max;
	}
	
	/** Un test sur le test pour viter les ennuis ! */
	@Test
	public void maxDistance() {
		assertEquals(0, maxDistance(new Cube(), new Cube()));
		assertEquals(1, maxDistance(new Cube(0, 1, 0), new Cube()));
		assertEquals(2, maxDistance(new Cube(0, 1, 0), new Cube(0, 1, 2)));
		assertEquals(3, maxDistance(new Cube(-1, 1, 0), new Cube(2, 1, 2)));
	}

	@Test
	public void getPositions() {
		Cube zero = new Cube(0, 0, 0);
		for (PuzzlePart part : PuzzlePart.values())
			for (int i=0; i<part.getPositions().length; i++) {
				boolean hasZero = false;
				for (int j=0; j<part.getPositions()[i].length; j++) {
					assertNotNull("Nullit pour la pice "+part+" en i="+i+" et j="+j, part.getPositions()[i][j]);
					if (part.getPositions()[i][j].equals(zero))
						hasZero = true;
					for (int k=0; k<part.getPositions()[i].length; k++) {
						assertTrue("Position n"+i+" de la pice "+part+" possde un doublon entre cubes n "+j+" et "+k, j == k || ! part.getPositions()[i][k].equals(part.getPositions()[i][j]));
						if (part == PuzzlePart.Z || part == PuzzlePart.L || part == PuzzlePart.T)
							assertTrue("Position n"+i+" de la pice "+part+" possde un cart excessif entre cubes n "+j+" et "+k, maxDistance(part.getPositions()[i][k], part.getPositions()[i][j]) < 3);
						else
							assertTrue("Position n"+i+" de la pice "+part+" possde un cart excessif entre cubes n "+j+" et "+k, maxDistance(part.getPositions()[i][k], part.getPositions()[i][j]) < 2);
					}
				}
				assertTrue("Position n"+i+" de la pice "+part+" ne passe pas par (0, 0, 0)", hasZero);
			}
	}
}
